define spawnID     $19
define set_seed    $34 ; 3 bytes - rng_seed, rng_seed+1, spawnCount
define set_seed_input $37 ; copied to set_seed during gameModeState_initGameState
define ssi2 $39
define ss2 $36
define tmp1        $00
define tmp2        $01
define tmp3        $02

init:

; seed into set_seed
lda #$12
sta set_seed
lda #$34
sta $35
lda #$56
sta ss2
; seed into set_seed_input
lda #$12
sta set_seed_input
lda #$34
sta $38
lda #$56
sta ssi2

; spawnTable
; $02,$07,$08,$0A,$0B,$0E,$12,$02
lda #$02
sta spawnTable
lda #$07
sta spawnTable2
lda #$08
sta spawnTable3
lda #$0A
sta spawnTable4
lda #$0B
sta spawnTable5
lda #$0E
sta spawnTable6
lda #$12
sta spawnTable7
lda #$02
sta spawnTable8

loop1:
jsr pickTetriminoSeed
jmp loop1

pickTetriminoSeed:
        jsr setSeedNextRNG

        ; SPSv3

        lda ssi2
        ror
        ror
        ror
        ror
        and #$F
        ; v3
        cmp #0
        bne xnotZero
        lda #$10
xnotZero:
        ; v2
        ; cmp #0
        ; beq xcompatMode

        adc #1
        sta tmp3 ; step + 1 in tmp3
xloop:
        jsr setSeedNextRNG
        dec tmp3
        lda tmp3
        bne xloop
xcompatMode:

        inc ss2 ; 'spawnCount'
        lda set_seed
        clc
        adc ss2
        and #$07
        cmp #$07
        beq xinvalidIndex
        tax
        lda spawnTable,x
        cmp spawnID
        bne xuseNewSpawnID
xinvalidIndex:
        ldx #set_seed
        ldy #$02
        jsr generateNextPseudorandomNumber
        lda set_seed
        and #$07
        clc
        adc spawnID
xL992A:
        cmp #$07
        bcc xL9934
        sec
        sbc #$07
        jmp xL992A

xL9934:
        tax
        lda spawnTable,x
xuseNewSpawnID:
        sta spawnID
        rts

setSeedNextRNG:
        ldx #set_seed
        ldy #$02
        jsr generateNextPseudorandomNumber
        rts

;reg x: zeropage addr of seed; reg y: size of seed
generateNextPseudorandomNumber:
        lda tmp1,x
        and #$02
        sta tmp1
        lda tmp2,x
        and #$02
        eor tmp1
        clc
        beq xupdateNextByteInSeed
        sec
xupdateNextByteInSeed:
        ror tmp1,x
        inx
        dey
        bne xupdateNextByteInSeed
        rts

spawnTable:
        nop
spawnTable2:
        nop
spawnTable3:
        nop
spawnTable4:
        nop
spawnTable5:
        nop
spawnTable6:
        nop
spawnTable7:
        nop
spawnTable8:
        nop
