#!/usr/bin/env python3
"""
SPS Search for Dupe
by Javantea
July 27, 2022

Find seeds with same output.
This is very slow, so use pypy3 or run multithreaded.
3m 36s on pypy3 with 32 threads.
"""
import tetris_sps
import multiprocessing
from collections import Counter

def getSequence(args):
    seed, num_pieces = args
    sps = tetris_sps.ThreadSafeSPS(seed)
    v = ''.join([tetris_sps.lookup[sps.pickTetriminoSeed()] for i in range(num_pieces)])
    return (seed, v)

def main():
    import sys
    if len(sys.argv) > 1:
        start = int(sys.argv[1])
    max_i = 0
    num_pieces = 30
    pool = multiprocessing.Pool()
    res = pool.imap(getSequence, [(x, num_pieces) for x in range(0x1000000)], chunksize=1000)
    counter = Counter()
    for seed, seq in res:
        counter[seq] += 1
    print(counter.most_common(1000000))

if __name__ == '__main__':
    main()
